Unit
  Cards;
Interface
Uses
   Memory,
   Drivers,
   Objects,
   Views;
Const
  MaxLabels      = 10;
  cmSelectLabel  = 888;


Type
  PLabel   = ^TLabel;
  TLabel   = Record
    Current, Last : PView;
    State         : Word;
    aLabel        : PString;
  end;
  PLabels  = ^TLabels;
  TLabels  = Array[0..MaxLabels-1] of TLabel;

  PCardView = ^TCardView;
  TCardView = Object(TView)
    Constructor Init( Var Bounds : TRect );
    Procedure Draw;                                             Virtual;
    Procedure GDraw;                                            Virtual;
    Procedure ClearContents;                                    Virtual;
    Procedure HandleEvent( Var Event : TEvent );                Virtual;
  end;

  PCardGroup = ^TCardGroup;
  TCardGroup = Object(TGroup)
    Labels       : TLabels;
    ActiveLabel  : PLabel;
    Ground       : PCardView;
    Constructor Init( Var Bounds: TRect );
    Destructor Done;                                            Virtual;
    Procedure HandleEvent(var Event: TEvent);                   Virtual;
    Procedure ChangeBounds(var Bounds: TRect);                  Virtual;
    Function CurrentLabel : Integer;                            Virtual;
    Procedure SelectLabel( aLabel : Integer; Clear : Boolean ); Virtual;
    Procedure ChangeLabel( NewLabel : String);                  Virtual;
    Procedure EnableLabel( Enable : Boolean);                   Virtual;
  end;

  PCardFrame = ^TCardFrame;
  TCardFrame = Object(TFrame)
    Constructor Init( Var Bounds : TRect );
    Function GetPalette : PPalette;                             Virtual;
    Procedure Draw;                                             Virtual;
    Procedure GDraw;                                            Virtual;
    Procedure ClearContents;                                    Virtual;
    Procedure HandleEvent( Var Event : TEvent );                Virtual;
  end;

  PCardWindow = ^TCardWindow;
  TCardWindow = Object(TWindow)
    Labels      : TLabels;
    ActiveLabel : PLabel;
    Constructor Init( Var Bounds  : TRect;
                          ATitle  : TTitleStr;
                          ANumber : Integer);
    Destructor Done;                                            Virtual;
    Procedure InitFrame;                                        Virtual;
    Procedure HandleEvent(var Event: TEvent);                   Virtual;
    Procedure ChangeBounds(var Bounds: TRect);                  Virtual;
    Function CurrentLabel : Integer;                            Virtual;
    Procedure SelectLabel( aLabel : Integer; Clear : Boolean ); Virtual;
    Procedure ChangeLabel( NewLabel : String);                  Virtual;
    Procedure EnableLabel( Enable : Boolean);                   Virtual;
  end;

Implementation
Const
  fmCloseClicked = $0001;
  fmZoomClicked  = $0002;
{}
Procedure ResetCursor(_Self : Pointer); Assembler;
asm
        LES     DI,_Self
        MOV     AX,ES:[DI].TView.State
        NOT     AX
        TEST    AX,sfVisible+sfCursorVis+sfFocused
        JNE     @@4
        MOV     AX,ES:[DI].TView.Cursor.Y
        MOV     DX,ES:[DI].TView.Cursor.X
@@1:    OR      AX,AX
        JL      @@4
        CMP     AX,ES:[DI].TView.Size.Y
        JGE     @@4
        OR      DX,DX
        JL      @@4
        CMP     DX,ES:[DI].TView.Size.X
        JGE     @@4
        ADD     AX,ES:[DI].TView.Origin.Y
        ADD     DX,ES:[DI].TView.Origin.X
        MOV     CX,DI
        MOV     BX,ES
        LES     DI,ES:[DI].TView.Owner
        MOV     SI,ES
        OR      SI,DI
        JE      @@5
        TEST    ES:[DI].TView.State,sfVisible
        JE      @@4
        LES     DI,ES:[DI].TGroup.Last
@@2:    LES     DI,ES:[DI].TView.Next
        CMP     CX,DI
        JNE     @@3
        MOV     SI,ES
        CMP     BX,SI
        JNE     @@3
        LES     DI,ES:[DI].TView.Owner
        JMP     @@1
@@3:    TEST    ES:[DI].TView.State,sfVisible
        JE      @@2
        MOV     SI,ES:[DI].TView.Origin.Y
        CMP     AX,SI
        JL      @@2
        ADD     SI,ES:[DI].TView.Size.Y
        CMP     AX,SI
        JGE     @@2
        MOV     SI,ES:[DI].TView.Origin.X
        CMP     DX,SI
        JL      @@2
        ADD     SI,ES:[DI].TView.Size.X
        CMP     DX,SI
        JGE     @@2
@@4:    MOV     CX,2000H
        JMP     @@6
@@5:    MOV     DH,AL
        XOR     BH,BH
        call    SetCursorPos
        MOV     CX,CursorLines
        LES     DI,_Self
        TEST    ES:[DI].TView.State,sfCursorIns
        JE      @@6
        MOV     CH,0
        OR      CL,CL
        JNE     @@6
        MOV     CL,7
@@6:    call    SetCursorSizeShape
end;
{}
{$I CARDS.I01 }                               { TCardView implementation }
{$I CARDS.I02 }                              { TCardGroup implementation }
{$I CARDS.I03 }                              { TCardFrame implementation }
{$I CARDS.I04 }                             { TCardWindow implementation }
{}
end.