{*******************************************************}
{                                                       }
{ File name         : PRMTXT.PAS                        }
{ Last edition date : 31-Mar-1994, 8:02:04              }
{                                                       }
{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Turbo Vision Unit                               }
{                                                       }
{       Copyright (c) 1992 Borland International        }
{                                                       }
{       Graphics:                                       }
{       Copyright (c) 1994 AE (A. Eltsyn)               }
{                                                       }
{*******************************************************}
Unit
   PrmTxt;
Interface
Uses
   Objects,
   Views,
   Dialogs;
Type
    PParamTXT = ^TParamTxt;
    TParamTxt = Object(TStaticText)
                  Params : Array [1..10] of Pointer;
                  Constructor Init( y,x1,x2 : Integer;
                                    Const AText: String );
                  Function DataSize : Word;                      Virtual;
                  Procedure GetText( Var S : String );           Virtual;
                  Procedure SetData( Var List );                 Virtual;
                  Procedure AddParameter( Var R );
                end;

Function NewFormatStr( Format: String; Var Params ) : String;

Implementation
{}
{}
{}
Constructor TParamTxt.Init( y,x1,x2 : Integer; Const AText: String);
Var R : TRect;
  begin
    R.Assign(x1,y,x2,y+1);
    Inherited Init(R, AText);
  end;
{}
Function TParamTxt.DataSize: Word;
Var i : Integer;
  begin
    i:=0;
    While (i<9) and (Params[i+1]<>Nil) do Inc(i);
    DataSize := i*4;
  end;
{}
Procedure TParamTxt.GetText(Var S: String);
 begin
   if Text <> nil then s:=NewFormatStr(Text^, Params) else S := '';
 end;
{}
Procedure TParamTxt.SetData( Var List );
  begin
    Move(List,Params,DataSize);
    DrawView;
  end;
{}
Procedure TParamTxt.AddParameter( Var R );
Var i : Byte;
  begin
    i:=1;
    While (i<10) and (Params[i]<>Nil) do Inc(i);
    Params[i]:=Addr(R);
    DrawView;
  end;
{}
{}
{}
{}



Function NewFormatStr( Format: String; Var Params ) : String;
Type PP = Array[1..100] of Pointer;

  Function HexB(B : Byte):String;
  Const Chars : Array[0..15] of Char = '0123456789ABCDEF';
    begin
      HexB:=Chars[b shr 4]+Chars[b and $0F];
    end;
  Function HexW(W : Word): String;
    begin
      HexW:=HexB(Hi(W))+HexB(Lo(W));
    end;
  Function Address(P : Pointer) : String;
    begin
      Address:=HexW(PTRRec(P).Seg)+':'+HexW(PTRRec(P).Ofs);
    end;
  Function Bool(b : Boolean) : String;
    begin
      If b then Bool:='TRUE' else Bool:='FALSE';
    end;

Var
   i,Jstf,PNo     : Byte;
   w,k            : Integer;
   s,Result       : String;

  begin
    Result:=''; i:=1; PNo:=1;

    While i<=Byte(Format[0]) do
      begin
        If Format[i]<>'%' then
          begin
            Result:=Result+Format[i];
            Inc(i);
          end else
          begin
            Inc(i); If i>Byte(Format[0]) then Break;
            If Format[i]='-' then begin jstf:=1; Inc(i) end else
             If Format[i]='=' then begin jstf:=2; Inc(i) end else
              If Format[i]='+' then begin jstf:=3; Inc(i) end else jstf:=3;
            If i>Byte(Format[0]) then Break;
            s:='0';
            While (i<=Byte(Format[0])) and (Format[i] in ['0'..'9']) do
              begin s:=s+Format[i]; Inc(i) end;
            If i>Byte(Format[0]) then Break;
            Val(s,w,k);
            If k<>0 then Break else If w>255 then w:=255;
            Case UpCase(Format[i]) of
              'S': s:=String(PP(Params)[PNo]^);
              'I': Str(Integer(PP(Params)[PNo]^):1,s);
              'D': Str(LongInt(PP(Params)[PNo]^):1,s);
              'C': s:=Char(PP(Params)[PNo]^);
              'W': s:=HexW(Word(PP(Params)[PNo]^));
              'P': s:=Address(Pointer(PP(Params)[PNo]^));
              'L': s:=Bool(Boolean(PP(Params)[PNo]^));
              '#': begin PNo:=w; Break; end;
              else Break;
            end;
            If PP(Params)[PNo]=Nil then s:='';
            Inc(PNo); Inc(i);
            If w>0 then
              Case Jstf of
                1:begin
                    If Byte(s[0])>w then Byte(s[0]):=w;
                    While Byte(s[0])<w do s:=s+' ';
                  end;
                2:begin
                    While Byte(s[0])<w do s:=' '+s+' ';
                    If Byte(s[0])>w then Byte(s[0]):=w;
                  end;
                3:begin
                    While Byte(s[0])>w do Delete(s,1,1);
                    While Byte(s[0])<w do s:=' '+s;
                  end;
              end;
            Result:=Result+s;
          end;
      end;
    NewFormatStr:=Result;
  end;
{
 Function:
    A modified Turbo Vision string formatting routine ( see FofmatStr
for more information ).
    Format specifiers are of the form %[-|=|+][nnn]X , where:

[-|=|+]   is an optional sign indicating the parameter is to be justified:
    '-' means the parameter should be left-justified
    '=' ............................     centered
    '+' (default)...................  right-justified

[nnn]    is an optional, decimal-number width specifier in the range
         0..255 (0 indicates no width specified, and non-zero means
         to display in a field of nnn characters)

X is a format character:

's'   means the parameter is a pointer to a string.
'i'   --//-- integer.
'd'   --//-- longint to be displayed in decimal.
'c'   --//-- character.
'w'   --//-- word to be displayed in hexadecimal.
'l'   --//-- boolean
'p'   --//-- pointer to be displayed as a address.
'r'   --//-- real
'f'   --//-- float
'x'   means the parameter is a Longint to be displayed in hexadecimal.
'#'   sets the parameter index to nnn.

    Params is an array of arguments, containing enough parameters to
match each of the format specifiers in Format. Params must be a
zero-based array of pointers to variables or a record containing
pointers.
}
end.
