{*******************************************************}
{                                                       }
{ File name         : TVGHC.PAS                         }
{ Last edition date : 27-Jul-1994,10:55:48              }
{                                                       }
{*******************************************************}
{                                                       }
{       Copyright (c) 1994 AE (A. Eltsyn)               }
{                                                       }
{*******************************************************}
{$V-}
Uses
   TVGHelp,
   TpString,
   Drivers,
   Objects,
   Dos;
Const
   MaxTopics = 600;
Type
  PStack       = ^TStack;
  TStack       = Record
                   F    : Text;
                   Name : String[80];
                   Line : Word;
                   Next : PStack;
                 end;
Var
   SourcePath   : PathStr;
   HelpFileName : PathStr;
   Stack        : PStack;
   Help         : PHelpWindow;
   TotalLines   : Word;
   TopicSize    : TPoint;
   ErrorCount   : Word;

{}
{$I TVGHC.I00} { ReadKey,ExistFile,DeleteFile,Error,FatalError,
                 HelpScreen implementation }
{$I TVGHC.I01} { EndOfText,GetString,ReSetText,CloseText implementation }
{$I TVGHC.I02} { ExtractTopic,ExtractSize implementation }
{$I TVGHC.I03} { PassOne implementation }
{$I TVGHC.I04} { PassTwo implementation }
{}

Var
   s,s1,s2 : String[80];
begin

{$I-}
  WriteLn;
  Writeln('TVGHelp v1.2 text file converter.     (C) by AE. ');

  If (ParamCount=0) or (ParamCount>2) or
     (Pos('/H',StUpCase(ParamStr(1)))>0) or
     (Pos('?',ParamStr(1))>0) then HelpScreen;

  FailSysErrors:=True;

  FSplit(ParamStr(1),SourcePath,s,s1);
  If SourcePath='' then
    begin
      GetDir(0,SourcePath);  SourcePath:=AddBackSlash(SourcePath)
    end;

  If ParamCount=1 then HelpFileName:=SourcePath+s+'.hlp' else
    begin
      FSplit(ParamStr(2),s,s1,s2);
      If s2='' then HelpFileName:=s+s1+'.hlp'
               else HelpFileName:=ParamStr(2);
    end;
  RegisterTVGHelp;

  Stack:=Nil;
  ErrorCount:=0;
  TopicSize.X:=56; TopicSize.Y:=14;

  New(Help,Init(HelpFileName));
  Dispose(Help^.HelpFile,Done);
  New(Help^.HelpFile, Init(New(PBufStream,
       Init(HelpFileName,stCreate,1024))));

  If Help^.HelpFile^.Stream^.Status <> stOk
    then FatalError('Can''t create file '+HelpFileName);

  New(Help^.Index,Init);

  Writeln(' Source file : '+ParamStr(1));
  Writeln(' Help file   : '+HelpFileName);

  PassOne;
  If ErrorCount=0 then PassTwo;

  Help^.HelpFile^.Put(Help^.Index,'HELPINDEX');
  Dispose(Help,Done);
  Writeln;
  If ErrorCount>0 then
    begin
      Writeln('Found ',ErrorCount:1,' errors.');
      DeleteFile(HelpFileName);
      Halt(1);
    end else Writeln('No more errors.');
end.
