{*******************************************************}
{                                                       }
{ File name         : TVGHELP.PAS                       }
{ Last edition date : 07-Sep-1994,13:11:28              }
{                                                       }
{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Turbo Vision Unit                               }
{                                                       }
{       Copyright (c) 1994 AE (A. Eltsyn)               }
{                                                       }
{*******************************************************}
Unit TVGHelp;
{$O+}
Interface
Uses
   Objects,
   Drivers,
   Views,
   Dialogs,
   MSGBOX,
   Editors,
   TpString;
Const
   CHelpTopic = #7#8#9#10#11#12;
{ Normal text
  Special attr. #1
  Special attr. #2
  Normal XRef
  Selected XRef
  Default image attr.
}
  CHelpWindow =
  #77#78#79#80#81#82#83#84#85#86#87#88#0#0#0#0#0#0#89#90#91#92#93;
{                    Ŀ                  
                   Ŀ                  
                 Ŀ                  
               Ŀ                    
             Ŀ                     
           Ŀ                     
         Ŀ                      
       Ŀ                       
     Ŀ                       
   Ŀ                       
1.  Passive Frame ٳ                       
2.  Active Frame ٳ                       
3.  Passive Title                        
4.  Active Title                       
5.  Scroll bar indicatorٳ                     
6.  Scroll bar arrows                      
7.  Normal text                     
8.  Special text attribute #2 ٳ                  
9.  Special text attribute #3 ٳ                  
10. Inactive XRef ٳ                  
11. Selected XRef                   
12. Default image attribute                       
19. Button Normal         
20. Button Default       
21. Button Selected     
22. Button Disabled   
23. Button Shortcut 
}

   MaxLinesInTopic = 200;
Type
  TAlias    = String[10];
  PMemoData = ^TMemoData;

  PXRef      = ^TXRef;
  TXRef      = Record
    x,y,Width : Integer;
    Ctx       : Word;
    Next      : PXRef;
  end;

  PImage     = ^TImage;
  TImage     = Record
    x,y          : Integer;
    ImType       : Byte;
    Size         : Word;
    Data         : Pointer;
    Next         : PImage;
  end;

  PIDX = ^TIDX;
  TIDX = Record
    Ctx   : Word;
    Alias : TAlias;
    Next  : PIDX;
  end;

  PHelpIndex = ^THelpIndex;
  THelpIndex = Object(TObject)
    IDXs     : PIDX;
    Constructor Init;
    Destructor Done;                                            Virtual;
    Constructor Load( Var S: TStream);
    Procedure Store( Var S: TStream);
    Procedure Add(IDX : TIDX);
    Function Ctx2Key(Ctx : Word) : String;
    Function Alias2Key( Alias : TAlias) : String;
    Function Alias2Ctx( Alias : TAlias) : Word;
    Function FindAlias(Alias : TAlias) : Boolean;
    Procedure AssumeFreeCtx;
    Function N : Word;
  Private
    Procedure Dispose;
  end;
{}

Type
  PHelpTopic = ^THelpTopic;
  THelpTopic = Object(TScroller)
    Title    : String[80];
    XRefs    : PXRef;
    Images   : PImage;
    Lines    : Array[0..MaxLinesInTopic] of PString;
    CurXRef  : PXRef;

    Constructor Init(Bounds : TRect;
                     AHScrollBar, AVScrollBar : PScrollBar);
    Destructor Done;                                            Virtual;
    Procedure Draw;                                             Virtual;
    Procedure DrawXRefs(NewXRef : PXRef);
    Procedure GDraw;                                            Virtual;
    Function GetPalette: PPalette;                              Virtual;
    Procedure HandleEvent(Var Event : TEvent);                  Virtual;

    Constructor Load(Var S: TStream);
    Procedure Store(Var S: TStream);
    Procedure ReSet;

    Procedure AddXRef(XRef : TXRef);
    Procedure AddImage(Image : TImage);
    Procedure AddLine(Line : String);

    Procedure DisposeXRefs;
    Procedure DisposeImages;
    Procedure DisposeLines;

  end;


Type
  PHelpWindow = ^THelpWindow;
  THelpWindow = Object(TDialog)
    FileName    : String;
    HelpFile    : PResourceFile;
    Index       : PHelpIndex;
    Topic       : PHelpTopic;
    Stack       : Array[0..10] of Word;
    CurCtx      : Word;
    HSB,VSB     : PScrollBar;
    BMain,BPrev : PButton;

    Constructor Init( AFileName  : String );
    Destructor Done;                                            Virtual;

    Function GetPalette: PPalette;                              Virtual;
    Procedure ChangeBounds(var Bounds: TRect);                  Virtual;
    Function DataSize : Word;                                   Virtual;
    Procedure GetData(Var Rec );                                Virtual;
    Procedure SetData(Var Rec );                                Virtual;
    Procedure HandleEvent(Var Event : TEvent);                  Virtual;

    Procedure LoadTopic(Key : String);
    Procedure PushCtx(Ctx : Word);
    Function PopCtx : Word;


  end;


Procedure RegisterTVGHelp;

Implementation

Const
    cmMainTopic = 200;
    cmNextTopic = 201;
    cmPrevTopic = 202;

Const
  RHelpIndex: TStreamRec = (
    ObjType: 65000;
    VmtLink: Ofs(TypeOf(THelpIndex)^);
    Load:    @THelpIndex.Load;
    Store:   @THelpIndex.Store );

  RHelpTopic: TStreamRec = (
    ObjType: 65001;
    VmtLink: Ofs(TypeOf(THelpTopic)^);
    Load:    @THelpTopic.Load;
    Store:   @THelpTopic.Store );

{$I TVGHelp.i00 } { THelpIndex implementation }
{$I TVGHelp.i01 } { THelpTopic implementation }
{$I TVGHelp.i02 } { THelpWindow implementation }

Procedure RegisterTVGHelp;
  begin
    RegisterType(RHelpIndex);
    RegisterType(RHelpTopic);
  end;
end.
