{*******************************************************}
{                                                       }
{ File name         : STRRSC.PAS                        }
{ Last edition date : 14-Jul-1994,10:18:16              }
{                                                       }
{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Turbo Vision Unit                               }
{                                                       }
{       Copyright (c) 1992 Borland International        }
{                                                       }
{       Graphics:                                       }
{       Copyright (c) 1994 AE (A. Eltsyn)               }
{                                                       }
{*******************************************************}
{$V-,X+}
Uses
   TPCrt,
   TPString,
   Dos;
Const
  Signature : Array [1..4] of Char = 'FBMS';

Type
  TFileRec     = record
                   Handle: Word;
                   Mode: Word;
                   RecSize: Word;
                   Private: array[1..26] of Byte;
                   UserData: array[1..16] of Byte;
                   Name: array[0..79] of Char;
                 end;

  PTxtBuffer   = ^TTxtBuffer;
  TTxtBuffer   = Array[0..60000] of Byte;
  PHeader      = ^THeader;
  THeader      = Array[1..20000] of Record
                                      Key : Word;
                                      Len : Byte
                                    end;
  PStack       = ^TStack;
  TStack       = Record
                   F    : Text;
                   Line : Word;
                   Prev : PStack;
                 end;

Var
  TxtBuffer    : PTxtBuffer;
  Header       : PHeader;
  Stack,_Stack : PStack;
  Proceed      : Set Of Char;

  Dest         : File;
  s,s1,s2,s3   : String;
  FindError    : Integer;
  n,p,a        : Word;
  Flag         : Boolean;
  Sel,NextSel  : Char;

Procedure Error( Msg : String);
  begin
    Writeln(Pad(Msg,70));
    Halt(1);
  end;

Procedure SyntaxError( Msg : String);
  begin
    Writeln(^M,Trim(ParamStr(1)),'(',Stack^.Line:1,'): ',Msg);
    Inc(FindError);
  end;

Procedure Compile(      SR   : String;
                    Var ID   : Word;
		    Var Dest : String);
Var
  s,s1  : String;
  a,b   : Integer;
  q	: Boolean;
  begin
    ID:=0; Dest:='';
    Sr:=Trim(SR);
    If (SR='') OR (Pos(';',SR)=1) then Exit;
    If (Pos(':',SR)=0) then begin SyntaxError('Invalid string ID');Exit end;
    s1:=Copy(sr,1,Pos(':',SR)-1);

    If Not (s1[Length(s1)] in ['0'..'9']) then
      begin
        If (Sel=#0)
          then begin Sel:=UpCase(s1[Length(s1)]);Include(Proceed,Sel) end
          else If (NextSel=#0) and Not (UpCase(s1[Length(s1)]) in Proceed)
            then NextSel:=UpCase(s1[Length(s1)]);
      end;
    If Not (s1[Length(s1)] in ['0'..'9']) then
      If (Sel<>#0) AND (Sel<>UpCase(s1[Length(s1)])) then Exit;

    If Not (s1[Length(s1)] in ['0'..'9']) then Delete(s1,Length(s1),1);
    Val(s1,ID,a);
    If a<>0 then begin SyntaxError('Invalid string ID'); ID:=0; Exit end;
    Delete(SR,1,Pos(':',SR));
    sr:=Trim(sr); s:=''; q:=False;
    repeat
      If q  then
        begin
          If Pos('''''',sr)=1
	    then begin Delete(sr,1,2); s:=s+#39 end
	    else If sr[1]=#39
              then begin Delete(sr,1,1); q:=False end
              else begin s:=s+sr[1];Delete(sr,1,1) end;
        end else
        begin
          sr:=Trim(sr); q:=sr[1]=#39;
	  Case sr[1] of
            '+',',','''': Delete(sr,1,1);
            ';':sr:='';
	    '#':begin
                  Delete(sr,1,1); sr:=Trim(sr);  s1:='';
                  While (sr[1] in ['0'..'9']) and (Length(sr)>0) do
                    begin s1:=s1+sr[1]; Delete(sr,1,1) end;
                  Val(s1,b,a);
                  If a<>0 then SyntaxError('Invalid char code');
                  s:=s+Chr(b);
                end;
	    else begin SyntaxError('Syntax error'); sr:='' end;
          end;
        end;
    until (sr='');
    If q then SyntaxError('String constant exceeds line')
         else Dest:=s;
  end;

  Procedure DWError;
    begin
      Error('Disk write error.                                 ');
    end;
Var
    LI : LongInt;
begin
  Writeln; DirectVideo:=False;
  WriteLn('String resurce compiler  v1.1     (C) AE (A.Eltsyn) 2/5/1994');
  If (ParamCount<1) or (ParamCount>2) then
     Error('Usage : TVGRSC <textfilename> [destfilename]'#13#10+
    '   Source file line format:'#13#10+
    '     Source_file_line  ::= <LINE> | include <filename> | ;<COMMENTS> '#13#10+
    '     <LINE>  ::= <STRINGID><SELECTOR>:<STRING_CONSTANT>');

  Fsplit(ParamStr(1),s,s1,s2); s:=s+s1+'.msg';
  If ParamCount=2 then s:=Trim(ParamStr(2));


  {$I-}

  Assign(Dest,s); ReWrite(Dest,1);
  If IOResult<>0 then Error('Unable to create file '+s);

  New(TxtBuffer); New(Header);
  If (TxtBuffer=Nil) or (Header=Nil) then Error('Not enough memory');

  NextSel:=#0; Proceed:=[#0,#255];
  Repeat
    n:=0; p:=0; New(Stack); Stack^.Prev:=Nil;
    Sel:=NextSel; NextSel:=#0;
    Include(Proceed,Sel);
    Assign(Stack^.F,ParamStr(1)); ReSet(Stack^.F);
    Stack^.Line:=0;
    Repeat
      While Not Eof(Stack^.F) do
        begin
          ReadLn(Stack^.F,s);
          Inc(Stack^.Line);
          Write(^M, Sel,'>> ',TFileRec(Addr(Stack^.F)^).Name,
                     '(',Stack^.Line:1,')   ');

          s:=Trim(s);
          If (s='') or (Pos(';',s)=1) then else
          If (Pos('INCLUDE',StUpCase(s))=1) then
            begin
              Delete(s,1,7); s:=Trim(s);
              If Pos(';',s)<>0 then s:=Copy(s,1,Pos(';',s)-1);
              FSplit(s,s,s1,s2);
              If s='' then FSplit(ParamStr(1),s,s3,s3);
              s:=s+s1+s2;
              New(_Stack); _Stack^.Prev:=Stack; Stack:=_Stack;
              Stack^.Line:=0;
              Assign(Stack^.F,s);  ReSet(Stack^.F);
              If IOResult<>0 then Error('Unable to open file '+s);
              Write(^M,' ':78);
            end else
            begin
              Compile(s,Header^[N+1].Key,s1);
              Flag:=True;
              For a:=1 to N do
                Flag:=Flag AND (Header^[a].Key<>Header^[N+1].Key);
              If Not Flag then SyntaxError('Duplicate string identifier '+
                                    Long2Str(Header^[N+1].Key)+Sel);
              If Flag AND (Header^[N+1].Key<>0) then
                begin
                  Inc(n); Header^[n].Len:=Byte(s1[0]);
                  Move(s1[1],TxtBuffer^[p],Byte(s1[0]));
                  Inc(p,Byte(s1[0]));
                end;
            end;
        end;
      Close(Stack^.F);

      Writeln;
      If Stack<>Nil then
        begin
          _Stack:=Stack;
          Stack:=Stack^.Prev;
          Dispose(_Stack);
        end;
    until Stack=Nil;
    If n>0 then
      begin
        BlockWrite(Dest,Signature,4,a); If a<>4 then DWError;
        LI:=1+2+n*3+p+1;
        BlockWrite(Dest,LI,4,a); If a<>4 then DWError;

        BlockWrite(Dest,Sel,1,a); If a<>1 then DWError;
        BlockWrite(Dest,n,2,a); If a<>2 then DWError;
        BlockWrite(Dest,Header^,N*3,a); If a<>N*3 then DWError;
        BlockWrite(Dest,TxtBuffer^,p+1,a); If a<>p+1 then DWError;
      end;
  Until NextSel=#0;

  Close(Dest);
  If FindError>0 then
    begin
      Writeln(^M'Errors found : ',FindError,
               '                              ');
      Erase(Dest); Halt(1)
    end;

  Writeln(^M,'No more errors.                                              ');
end.
